%!
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% === Type de l'anamorphose ---------------------------------------------------
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
/Anamorphose_cylindrique 1 def
/Anamorphose_conique 2 def
/TypeAnamorphose Anamorphose_cylindrique def
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% === Translation et mise  une chelle des fichiers EPS ----------------------
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Le mcanisme est encore imparfait. Alors que scale affecte l'paisseur des
%% traits, Scale n'y touche pas ! Il faudra donc prvoir un droutage de 
%% l'intruction setlinewidth... ou une autre solution plus habile.
/s@@x 1 def /s@@y 1 def /t@@x 0 def /t@@y 0 def
/Scale {/s@@y ED /s@@x ED} def
/Translate {/t@@y ED /t@@x ED} def
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% === Capture de commandes de systemdict --------------------------------------
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
/LINETO    { systemdict /lineto get exec    } def
/MOVETO    { systemdict /moveto get exec    } def
/CURVETO   { systemdict /curveto get exec   } def
/CLOSEPATH { systemdict /closepath get exec } def
/RLINETO   { systemdict /rlineto get exec   } def
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% === Transformation des commandes de construction des path(s) ----------------
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% 11/10/2011 : version incomplte et un peu brute !
/tx@anamorphosisPathDict 50 dict def tx@anamorphosisPathDict begin
/moveto {
  /s@y ED /s@x ED /c@x s@x def /c@y s@y def
  s@x s@y Anamorphose MOVETO
} bind def
/lineto {
  /c@yt ED /c@xt ED /dx c@xt c@x sub 50 div def /dy c@yt c@y sub 50 div def
  1 1 50 {dup dx mul c@x add exch dy mul c@y add Anamorphose LINETO} for
  /c@x c@xt def /c@y c@yt def
} bind def
/closepath {
  s@x s@y lineto CLOSEPATH
  /c@x s@x def /c@y s@y def
} bind def
/curveto {
  /c@yt ED /c@xt ED
  /c@yb ED /c@xb ED
  /c@ya ED /c@xa ED
  1 1 20 {
    20 div /s ED 1 s sub /t ED
    t c@x mul 3 s c@xa mul mul add t mul 3 s s c@xb mul mul mul add t mul s 3 exp c@xt mul add
    t c@y mul 3 s c@ya mul mul add t mul 3 s s c@yb mul mul mul add t mul s 3 exp c@yt mul add
    Anamorphose LINETO
  } for
  /c@x c@xt def /c@y c@yt def
} bind def
/rlineto {
  c@y add exch c@x add exch lineto
} bind def
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% === L'anamorphose cylindrique (type 1) --------------------------------------
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
/tx@anamorphosisCYDict 100 dict def tx@anamorphosisCYDict begin
/fixeParametres {
  /Yv ED /Xv ED /R exch dup mul def
} def
/Anamorphose {
  /Yp exch t@@y add s@@y mul def  /Xp exch t@@x add s@@x mul def
  /a Xv Xp sub dup mul Yv Yp sub dup mul add def
  /b Xv Xp mul Yv Yp mul add Xv dup mul sub Yv dup mul sub def
  /c R neg Xv dup mul add Yv dup mul add def
  /d b dup mul a c mul sub 0.5 exp def
  /rho b neg d sub a div def
  /alpha 2 1 rho div sub def
  /xi Xv dup Xp sub rho mul sub def
  /yi Yv dup Yp sub rho mul sub def
  /k 2 Xv xi mul Yv yi mul add mul R div def
  /xv k xi mul Xv sub def
  /yv k yi mul Yv sub def
  xv dup xi sub alpha mul sub
  yv dup yi sub alpha mul sub
} def
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% === L'anamorphose conique (type 2) ------------------------------------------
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
/tx@anamorphosisCODict 100 dict def tx@anamorphosisCODict begin
/fixeParametres {
  /Zs ED /Zv ED /Rmirror ED
} def
/Anamorphose {
  /Yp exch t@@y add s@@y mul def /Xp exch t@@x add s@@x mul def
  /rP Xp dup mul Yp dup mul add 0.5 exp def
  /k Rmirror Zs Zv sub mul Zs rP mul Zv Rmirror mul sub div def
  /Xi k Xp mul def
  /Yi k Yp mul def
  k 0 eq {/Zi Zs def}{/Zi Zv 1 k sub mul def} ifelse
  /BETA rP Zv Atan def
  /THETA Rmirror Zs Atan def
  /ALPHA 90 2 THETA mul sub BETA add def
  /rI Xi dup mul Yi dup mul add 0.5 exp def
  /KP' Zi ALPHA sin ALPHA cos div div def
  /rP' rI KP' add def
  rP' Xp rP div mul
  rP' Yp rP div mul
} def
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% === Les commandes -----------------------------------------------------------
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
/Image {
  gsave
    /showpage {} def
    s@@x s@@y scale t@@x t@@y translate
    fichier run
  grestore
} def

/AnamorphoseCY {
  tx@anamorphosisCYDict begin
    tx@anamorphosisPathDict begin
      gsave
        fixeParametres
        /showpage {} def
        fichier run
      grestore
    end
  end
} def

/AnamorphoseCO {
  tx@anamorphosisCODict begin
    tx@anamorphosisPathDict begin
      gsave
        fixeParametres
        /showpage {} def
        fichier run
      grestore
    end
  end
} def

/Anamorphose {
  TypeAnamorphose 1 eq {AnamorphoseCY} if
  TypeAnamorphose 2 eq {AnamorphoseCO} if
} def
